from DecoyDuck    import DecoyDuck
from MallardDuck  import MallardDuck
from RedheadDuck  import RedheadDuck
from RubberDuck   import RubberDuck
from FlyWithWings import FlyWithWings
from Quack        import Quack

class DuckSimulator(object):

    def __init__(self):
        self.ducks = []

    def add_duck(self, duck):
        self.ducks.append(duck)

    def simulate(self):
        for duck in self.ducks:
            print "-" * 40 
            duck.display()
            duck.performFly()
            duck.performQuack()
            duck.swim()

if __name__ == '__main__':
    sim   = DuckSimulator()
    decoy = DecoyDuck()

    sim.add_duck(MallardDuck())
    sim.add_duck(RedheadDuck())
    sim.add_duck(RubberDuck())
    sim.add_duck(decoy)

    sim.simulate()

    decoy.setFlyBehavior(FlyWithWings())
    decoy.setQuackBehavior(Quack())

    sim.simulate()
